# Copyright : Filippo Rusconi
# License : GPL-3.0+
# Authors : Filippo Rusconi

find_path(RData_INCLUDE_DIRS rdata.h
  PATHS /usr/local/include /usr/include
  PATH_SUFFIXES rdata librdata ENV PATH)


find_library(RData_LIBRARIES NAMES rdata librdata rdatalib)

if(RData_INCLUDE_DIRS AND RData_LIBRARIES)
  set(RData_FOUND TRUE)
endif()

if(RData_FOUND)

  if(NOT RData_FIND_QUIETLY)
    message(STATUS "Found RData_LIBRARY: ${RData_LIBRARIES}")
  endif()

  if(NOT TARGET RData::Core)

    add_library(RData::Core UNKNOWN IMPORTED)

    set_target_properties(RData::Core PROPERTIES
      IMPORTED_LOCATION             "${RData_LIBRARIES}"
      INTERFACE_INCLUDE_DIRECTORIES "${RData_INCLUDE_DIRS}")

  endif()

endif()
